Subject: Re: [RFC][WIP] IEEE 802.15.4 implementation for Linux

From: Florian Fainelli <[email-masked]>
Date: Wed, 27 May 2009 11:58:55 +0200

Hi Dmitry,

Le Tuesday 26 May 2009 13:21:57 Dmitry Eremin-Solenikov, vous avez écrit :
> Hi,
>
> As a part of research activities in the Embedded Systems - Open Platform
> Group from Siemens Corporate Technology we are working on adding support
> for the IEEE 802.15.4 Wireless Personal Area Networks to the Linux. Our
> current implementation is neither certified nor even feature complete.
> However we'd like to present current state of our patchset to the Linux
> developers community to gain comments, fixes, ideas, etc. This is not yet a
> pull request, but more like an RFC.

Let met just thank you for doing this, I am glad some people worked on this. 
Got a couple of questions below.

>
> The project page is available at
> http://apps.sourceforge.net/trac/linux-zigbee with source code of kernel
> part available from git at
> http://zigbee-linux.git.sourceforge.net, mirrored for convenience at
> git://git.kernel.org/pub/scm/linux/kernel/git/lumag/lowpan.git
>
> The source code for userspace utils is available from git at
> http://linux-zigbee.git.sourceforge.net/

From the project page I understand that you plan on providing a ZigBee stack, 
based on this 802.15.4 stack ? Do you plan on submitting the ZigBee stack 
later on ?

Maybe you should mention that this implementation is royalty-free, but that 
commercial products using it should both respect the GPL license and pay a 
ZigBee royalty as per the ZigBee Alliance . That is just for clarification 
since right now it simply does 802.15.4 which is not subject to this royalty 
thing.

>
> Several comments about our implementation:
> * As with 802.11 there are two types of devices: the smart ones that
> implement most parts of the protocol by themselves and more or less dumb
> ones which simply send and receive what they are told. Currently we do only
> support the second type of devices (SoftMAC)
> * The implementation is split between code driving radio, (master, mwpanX
>   interface: mdev.c), code processing frames according the IEEE 802.15.4
>   rules (slave wpanX devices) and finally sockets (af_ieee802154.c,
> dgram.c, raw.c).

This sounds good. Do you also plan on integrating some meshing algorithm on 
top of 802.15.4 ? If so, 

> * We do present two example drivers using our stack. One is purely virtual
>   one either looping the packets back or connecting several virtual
> interfaces (the one at fakelb.c), and the driver for the Freescale MC13192
> evaluation boards (13192-SARD, 13192-EVK) using our custom firmware
> (currently only available at request, we are working on publishing it). The
> driver for the Atmel at86rf230/at86rf231 chips will follow in several
> weeks.

Is the virtual interface just like mac80211_hwsim for 802.11 ?h
-- 
Best regards, Florian Fainelli
Email : [email-masked]
http://openwrt.org
-------------------------------